#include <iostream>
#include <list>
#include <iostream>
#include <fstream>

using namespace std;

typedef struct POINT {
  int x;
  int y;
} POINT, *PPOINT;


typedef struct WINDOW {
  int A;
  int B;
  int S;  // free space window
  int N;  // number form on window
  int C;  // suma nice
  int **M;
} WINDOW, *PWINDOW;


typedef struct FRAME {
  int C ;   // weight
  int S ;   // space frame
  int W ;   // number window
  int X ;   // X coord
  int Y ;   // Y coord
  list <POINT> color ;
} FRAME, *PFRAME;

static const int limit = 10000 ;

WINDOW w[limit] ;
FRAME f[limit] ;
int ind[limit] ;  // list of index frame sort max first
int indw[limit] ; // list of index windows sort max first
int beauty = 0 ;
int savef[limit][3] ;
int Max ;
void fill ( int ) ;

int N , M ;
int  wN , wC ;

int main()
{
    ifstream in("decoration.in");
    ofstream out ;

    int backIndex = -10 ;

    in >> N >> M ;  // read dimension

    for ( int i = 0 ; i < N ; i++) {
      int A , B ;
      in >> A >> B  ;
      // get memory array window
      w[i].M = new int*[A]  ;
      for(int j = 0; j <  A; ++j)
        w[i].M[j] = new int[B];
      // init window
      for ( int n = 0 ; n < A ; n++ )
        for ( int m = 0 ; m < B ; m++ )
            w[i].M[n][m] = 0 ;
      w[i].A = A ; w[i].B = B ;  w[i].S = A * B ;
      w[i].N = 0 ; w[i].C = 0 ;
    }

    // get frame
    for ( int i = 0 ; i < M ; i++ ) {
        int P , Q , C , S , Z ;
        POINT a ;
        // read dimension
        in >> P >> Q >> C ;
        S = 0 ;
        for ( int n = 0 ; n < P ; n++ )
            for ( int m = 0 ; m < Q ; m++ ) {
                in >> Z ;
                if ( Z ) {
                    a.x = n ; a.y = m ;
                    f[i].color.insert (f[i].color.end() , a  ) ;
                    ++S ;
                }
            }
         f[i].C = C ; f[i].S = S ; f[i].W = -1 ;
         f[i].X = -1 ; f[i].Y = -1 ;
    }
    in.close() ;
    // init ind
    for ( int i = 0 ; i < M ; i++ ) ind [i] = i ;
    // sort ind
    for ( int i =  0 ; i < M - 1; i++ )
        for ( int j = i + 1 ; j < M  ; j++ ) {
            if ( f[ind[i]].C < f[ind[j]].C ) {
                int s ;  s = ind[i] ;
                ind[i] = ind[j] ;  ind[j] = s ;
            }
            if ( f[ind[i]].C == f[ind[j]].C && f[ind[i]].S > f[ind[j]].S ) {
                int s ;  s = ind[i] ;
                ind[i] = ind[j] ;  ind[j] = s ;
            }
        }
    // init indw
    for ( int i = 0 ; i < N ; i++ ) indw [i] = i ;
    // sort ind
    for ( int i =  0 ; i < N - 1; i++ )
        for ( int j = i + 1 ; j < N  ; j++ )
            if ( w[indw[i]].S < w[indw[j]].S ) {
                int s ;  s = indw[i] ;
                indw[i] = indw[j] ;  indw[j] = s ;
            }


    // main program , generate one solution
    for ( int k = 0 ; k < M ; k++ ) {
        int i = ind[k] ;
        for ( int l = 0 ; l < N ; l++) {
            int j = indw[l] ;
            if ( w[j].S >= f[i].S && f[i].W == -1 ) {
                // there are space , check
                int x , y , flag = 1  ;
                list<POINT>::iterator iP ;
                for ( x = 0 ; x < w[j].A ; x++)  {
                    if ( flag == 0 ) break ;
                    for ( y = 0 ; y < w[j].B ; y++) {
                        if ( flag == 0 ) break ;
                        flag = 0 ;
                        for (iP =  f[i].color.begin(); iP != f[i].color.end(); ++iP)
                            if (  (iP->x + x ) >  (w[j].A -1) || (iP->y + y ) > (w[j].B - 1) ||
                                w[j].M[iP->x + x][iP->y + y] == 1  ) { flag  = 1 ;  break ; }
                         if ( flag == 0 ) {  // fill matrix
                            for (iP =  f[i].color.begin(); iP != f[i].color.end(); ++iP)
                                w[j].M[iP->x + x][iP->y + y] = 1 ;
                             f[i].W = j + 1 ;  // window
                             f[i].X = x + 1  ;
                             f[i].Y = y + 1;
                             w[j].S = w[j].S - f[i].S ;
                             ++w[j].N ; w[j].C += f[i].C ;
                         }
                    }
                }
            }  // end if
        }  // end for window
    } // end for frame

    // print decision
    out.open("decoration.out");
    for ( int i = 0 ; i < M ; i++ )
        out << f[i].W << " " << f[i].X << " " << f[i].Y << endl ;
    out.close() ;
    // calaculate beauty
    for ( int i = 0 ; i < N   ; i++ )
        beauty += w[i].N * w[i].C ;

    // optimisation solution
    if ( M <= 9 ) {
    for ( int i = 0 ; i < N ; i++) {
      for ( int n = 0 ; n < w[i].A ; n++ )
        for ( int m = 0 ; m < w[i].B ; m++ )
            w[i].M[n][m] = 0 ;
         w[i].S = w[i].A * w[i].B ;
         w[i].N = 0 ; w[i].C = 0 ;
    }
    for ( int i = 0 ; i < M ; i++ ) {
        savef[i][0] = savef[i][1] = savef[i][2] = -1 ;

    }

    // fill window
    for ( int l = 0 ; l < N ; l++ ) {
       int i = indw[l] ;
       Max = 0 ; wN = 0 ; wC = 0 ;
       for ( int j=0 ; j < M ; j++ ) {
        f[j].W  = savef[j][0] ;  f[j].X = savef[j][1] ; f[j].Y = savef[j][2] ;
       }
       fill ( i ) ;
       w[i].N = wN ; w[i].C = wC ;
    }

        // calaculate beauty
    int tmp = 0 ;
    for ( int i = 0 ; i < N   ; i++ )
        tmp  += w[i].N * w[i].C ;
    if ( tmp > beauty ) {
        beauty = tmp ;
        out.open("decoration.out");
        for ( int i = 0 ; i < M ; i++ )
            out << f[i].W << " " << f[i].X << " " << f[i].Y << endl ;
        out.close() ;
   }



    }
    else {
          while ( 1 ) {
        //fix index back
        int i ;
        for (  i = 0 ; i < M -1 ; i++ )
            if ( f[ind[i]].W != -1 && f[ind[i+1]].W == -1    ) break ;
        if ( i == (M - 1)  ) break ;
        if ( i == backIndex ) break ;
        backIndex = i ;
        // init data
        for ( ; i < M ; i++ ) {
            if ( f[ind[i]].W != -1 ) {
                int j , x , y ;
                j =  f[ind[i]].W - 1 ;
                x =  f[ind[i]].X - 1 ;
                y =  f[ind[i]].Y - 1 ;
                --w[j].N ;  w[j].C -= f[ind[i]].C ;
                w[j].S = w[j].S + f[ind[i]].S ;

                list<POINT>::iterator iP ;
                for (iP =  f[ind[i]].color.begin(); iP != f[ind[i]].color.end(); ++iP)
                                w[j].M[iP->x + x][iP->y + y] = 0 ;
                f[ind[i]].W  = -1 ;
                f[ind[i]].X  = -1 ;
                f[ind[i]].Y  = -1 ;
            }
        }


        i = ind[backIndex] ;
        ind[backIndex] = ind[backIndex+1] ;
        ind[backIndex+1] = i ;

        // next fill

        for ( int k = backIndex ; k < M ; k++ ) {
          int i = ind[k] ;
          for ( int l = 0 ; l < N ; l++) {
            int j = indw[l] ;
            if ( w[j].S >= f[i].S && f[i].W == -1 ) {
                // there are space , check
                int x , y , flag = 1  ;
                list<POINT>::iterator iP ;
                for ( x = 0 ; x < w[j].A ; x++)  {
                    if ( flag == 0 ) break ;
                    for ( y = 0 ; y < w[j].B ; y++) {
                        if ( flag == 0 ) break ;
                        flag = 0 ;
                        for (iP =  f[i].color.begin(); iP != f[i].color.end(); ++iP)
                            if (  (iP->x + x ) >  (w[j].A -1) || (iP->y + y ) > (w[j].B - 1) ||
                                w[j].M[iP->x + x][iP->y + y] == 1  ) { flag  = 1 ;  break ; }
                         if ( flag == 0 ) {  // fill matrix
                            for (iP =  f[i].color.begin(); iP != f[i].color.end(); ++iP)
                                w[j].M[iP->x + x][iP->y + y] = 1 ;
                             f[i].W = j + 1 ;  // window
                             f[i].X = x + 1  ;
                             f[i].Y = y + 1;
                             w[j].S = w[j].S - f[i].S ;
                             ++w[j].N ; w[j].C += f[i].C ;
                         }
                    }
                }
            }  // end if
          }  // end for window
        } // end for frame

        // calaculate beauty
    int tmp = 0 ;
    for ( int i = 0 ; i < N   ; i++ )
        tmp  += w[i].N * w[i].C ;
    if ( tmp > beauty ) {
        beauty = tmp ;
        out.open("decoration.out");
        for ( int i = 0 ; i < M ; i++ )
            out << f[i].W << " " << f[i].X << " " << f[i].Y << endl ;
        out.close() ;
   }




    }
    }

   // free memory
   for ( int i = 0 ; i < N ; i++) {
      for(int j = 0; j < w[i].A; ++j)
        delete [] w[i].M[j] ;
      delete  [] w[i].M ;
    }

    return 0;
}


void fill ( int index ) {
    list<POINT>::iterator iP ;
    for ( int k = 0 ; k < M ; k++) {
        int i = ind[k] ; int flag = 1 ;
        if ( w[index].S >= f[i].S && f[i].W < 0 )  {
            int x , y ;
            for ( x = 0 ; x < w[index].A ; x++)  {
                if ( flag == 0 ) break ;
                for ( y = 0 ; y < w[index].B ; y++) {
                    if ( flag == 0 ) break ;
                    flag = 0 ;
                    for (iP =  f[i].color.begin(); iP != f[i].color.end(); ++iP)
                        if (  (iP->x + x ) >  (w[index].A -1) || (iP->y + y ) > (w[index].B - 1) ||
                            w[index].M[iP->x + x][iP->y + y] == 1  ) { flag  = 1 ;  break ; }
                    if ( flag == 0 ) {  // fill matrix
                         for (iP =  f[i].color.begin(); iP != f[i].color.end(); ++iP)
                                w[index].M[iP->x + x][iP->y + y] = 1 ;
                         f[i].W = index + 1 ;  // window
                         f[i].X = x + 1  ;
                         f[i].Y = y + 1;
                         w[index].S = w[index].S - f[i].S ;
                         ++w[index].N ; w[index].C += f[i].C ;
                    }
                }
            }
        }  // end if
        if ( flag == 0 ) {
            int tmp = w[index].N * w[index].C ;
            if ( Max < tmp ) {
                for ( int j = 0  ; j  <  M ; j++ ) {
                    savef[j][0] = f[j].W ;
                    savef[j][1] = f[j].X ;
                    savef[j][2] = f[j].Y ;

                 }
                Max = tmp ;
                wN = w[index].N ; wC =  w[index].C ;
            }
            fill ( index )  ;
            int x = f[i].X - 1 ;
            int y = f[i].Y - 1 ;
            for (iP =  f[i].color.begin(); iP != f[i].color.end(); ++iP)
                 w[index].M[iP->x + x][iP->y + y] = 0 ;
            f[i].W = -1 ;
            f[i].X = -1 ;
            f[i].Y = -1 ;
            w[index].S = w[index].S + f[i].S ;
            --w[index].N ; w[index].C -= f[i].C ;
        }
      }
    return ;
}


/* Dump input data
    cout << "N=" << N << " M=" << M << endl ;
    for ( int i = 0 ; i < N ; i++) {
       cout << "i="<< i << " w[i].A=" << w[i].A << " w[i].B=" << w[i].B <<  " w[i].S=" << w[i].S  << endl  ;
       cout << "w[i].N=" << w[i].N << " w[i].C=" << w[i].C <<  endl  ;
       for ( int n = 0 ; n < w[i].A ; n++ ) {
         cout << endl ;
        for ( int m = 0 ; m < w[i].B ; m++ )
            cout << w[i].M[n][m]  << " " ;
       }
       cout << endl ;
    }
    cout << endl ;
    for ( int i = 0 ; i < M ; i++ ) {
        list<POINT>::iterator iP ;
        cout << "i=" << i << " C=" << f[i].C << " S=" << f[i].S << endl ;
        cout << "W=" << f[i].W << " X=" << f[i].X << " Y=" << f[i].Y << endl ;
        for (iP =  f[i].color.begin(); iP != f[i].color.end(); ++iP)
          cout << "(" << iP->x << "," << iP->y << ") " ;
        cout << endl ;
    }

    cout << "sort max index " << endl ;
    for ( int i = 0 ; i < M ; i++ )
        cout << " " << ind[i] ;
    cout << endl ;


    cout << "sort max index window " << endl ;
    for ( int i = 0 ; i < N ; i++ )
        cout << " " << indw[i] ;
    cout << endl ;


    end dump input data */
